package com.sf.service.gateway.enums;

import org.springframework.util.StringUtils;

/**
 * 网关服务类型
 * 
 * @author zoukun
 */
public enum GatewayServiceType
{
    SAC("SAC", "SAC规范服务"),
    OPEN("OPEN", "开放服务"),
    ;

    private final String code;
    private final String info;

    GatewayServiceType(String code, String info)
    {
        this.code = code;
        this.info = info;
    }

    public String getCode()
    {
        return code;
    }

    public String getInfo()
    {
        return info;
    }

    public static GatewayServiceType getByCode(String code){
        if (StringUtils.hasText(code)) {
            for (GatewayServiceType value : GatewayServiceType.values()) {
                if (value.code.equals(code)){
                    return value;
                }
            }
        }
        return null;
    }
}
